<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="标题：" prop="title">
        <el-input v-model="formData.title" placeholder="请输入通知标题" />
      </el-form-item>
      <el-form-item label="应用平台:" prop="platformType">
        <el-radio-group v-model="formData.platformType">
          <el-radio :value="1">PC</el-radio>
          <el-radio :value="2">移动</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="图片" prop="imgUrl">
        <UploadImg v-model="formData.imgUrl" :limit="1">
          <template #tip>
            <span v-if="formData.platformType == 1">图片尺寸 845px*200px </span>
            <span v-if="formData.platformType == 2">图片尺寸 375px*180px </span>
          </template>
        </UploadImg>
      </el-form-item>
      <!-- <el-form-item label="内容：" prop="content">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="接收范围：" prop="rangeFlag">
        <el-select v-model="formData.rangeFlag" placeholder="请选择范围" style="width: 500px">
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="选择用户：" prop="userIds" v-if="formData.rangeFlag == 2">
        <AddUserSelectForm v-model="formData.userIds">请选择用户</AddUserSelectForm>
      </el-form-item> -->
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { NoticeApi, Notice } from '@/api/company/companynotice'

/** 公司通知 表单 */
defineOptions({ name: 'NoticeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  title: undefined,
  summary: undefined,
  imgUrl: undefined,
  content: undefined,
  rangeFlag: undefined,
  userIds: undefined,
  platformType: 1
})
const formRules = reactive({
  title: [{ required: true, message: '标题不能为空', trigger: 'change' }],
  summary: [{ required: true, message: '摘要不能为空', trigger: 'change' }],
  imgUrl: [{ required: true, message: '图片不能为空', trigger: 'blur' }],
  content: [{ required: true, message: '内容不能为空', trigger: 'change' }],
  rangeFlag: [{ required: true, message: '内接收范围不能为空', trigger: 'change' }],
  userIds: [{ required: true, message: '用户不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await NoticeApi.getNotice(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    formData.value.typeFlag = 4
    console.log('表单值：', formData.value)
    const data = formData.value as unknown as Notice
    if (formType.value === 'create') {
      await NoticeApi.createNotice(data)
      message.success(t('common.createSuccess'))
    } else {
      await NoticeApi.updateNotice(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    title: undefined,
    content: undefined,
    summary: undefined,
    imgUrl: undefined,
    rangeFlag: undefined,
    userIds: undefined,
    platformType: 1
  }
  formRef.value?.resetFields()
}
</script>
